Package org.apache.groovy.contracts.ast.visitor

# Class DynamicSetterInjectionVisitor

java.lang.Object
org.codehaus.groovy.ast.CodeVisitorSupport
org.codehaus.groovy.ast.ClassCodeVisitorSupport
org.apache.groovy.contracts.ast.visitor.BaseVisitor
org.apache.groovy.contracts.ast.visitor.DynamicSetterInjectionVisitor

All Implemented Interfaces:
  `GroovyClassVisitor`, `GroovyCodeVisitor`, `ErrorCollecting`

public class DynamicSetterInjectionVisitor extends BaseVisitor

Implements contract support for setter methods and default constructors of POGOs.

See Also:
  - `BaseVisitor`

- ## Field Summary

  ### Fields inherited from class org.apache.groovy.contracts.ast.visitor.BaseVisitor

  `GCONTRACTS_ENABLED_VAR, sourceUnit`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DynamicSetterInjectionVisitor(SourceUnit sourceUnit, ReaderSource source)`
  Creates a visitor that injects synthetic setters and constructors needed for invariant checks.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected Statement`
  `createSetterBlock(ClassNode classNode, FieldNode field, Parameter parameter)`
  Creates the body of a synthetic setter that wraps the assignment with invariant checks.
  `void`
  `visitClass(ClassNode classNode)`
  Prepares invariant-check blocks for the class and adds a synthetic default constructor when needed.
  `void`
  `visitProperty(PropertyNode node)`
  Adds a synthetic setter for invariant-checked properties when no explicit setter is present.

  ### Methods inherited from class org.apache.groovy.contracts.ast.visitor.BaseVisitor

  `asConditionExecution, getOriginalCondition, getReplacedCondition, getSourceUnit, replaceCondition`

  ### Methods inherited from class org.codehaus.groovy.ast.ClassCodeVisitorSupport

  `addError, visitAnnotation, visitAnnotations, visitAnnotations, visitAssertStatement, visitBlockStatement, visitBreakStatement, visitCaseStatement, visitCatchStatement, visitClassCodeContainer, visitClosureExpression, visitConstructor, visitConstructorOrMethod, visitContinueStatement, visitDeclarationExpression, visitDoWhileLoop, visitExpressionStatement, visitField, visitForLoop, visitIfElse, visitImports, visitMethod, visitObjectInitializerStatements, visitPackage, visitReturnStatement, visitStatement, visitStatementAnnotations, visitSwitch, visitSynchronizedStatement, visitThrowStatement, visitTryCatchFinally, visitWhileLoop, visitYieldStatement`

  ### Methods inherited from class org.codehaus.groovy.ast.CodeVisitorSupport

  `afterSwitchCaseStatementsVisited, afterSwitchCaseStatementsVisited, afterSwitchConditionExpressionVisited, afterSwitchConditionExpressionVisited, visitArgumentlistExpression, visitArrayExpression, visitAttributeExpression, visitBinaryExpression, visitBitwiseNegationExpression, visitBooleanExpression, visitBytecodeExpression, visitCastExpression, visitClassExpression, visitClosureListExpression, visitConstantExpression, visitConstructorCallExpression, visitEmptyStatement, visitFieldExpression, visitGStringExpression, visitLambdaExpression, visitListExpression, visitMapEntryExpression, visitMapExpression, visitMethodCallExpression, visitMethodPointerExpression, visitMethodReferenceExpression, visitNotExpression, visitPostfixExpression, visitPrefixExpression, visitPropertyExpression, visitRangeExpression, visitShortTernaryExpression, visitSpreadExpression, visitSpreadMapExpression, visitStaticMethodCallExpression, visitSwitchExpression, visitTernaryExpression, visitTupleExpression, visitUnaryMinusExpression, visitUnaryPlusExpression, visitVariableExpression`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface org.codehaus.groovy.ast.GroovyCodeVisitor

  `visit, visit, visitEmptyExpression, visitListOfExpressions`

- ## Constructor Details

  - ### DynamicSetterInjectionVisitor

    public DynamicSetterInjectionVisitor(SourceUnit sourceUnit, ReaderSource source)
    Creates a visitor that injects synthetic setters and constructors needed for invariant checks.
    Parameters:
      `sourceUnit` - the source unit currently being transformed
      `source` - the reader source backing the source unit

- ## Method Details

  - ### createSetterBlock

    protected Statement createSetterBlock(ClassNode classNode, FieldNode field, Parameter parameter)
    Creates the body of a synthetic setter that wraps the assignment with invariant checks.
    Parameters:
      `classNode` - the declaring class
      `field` - the field being written
      `parameter` - the synthetic setter parameter
    Returns:
      the generated setter body

  - ### visitProperty

    public void visitProperty(PropertyNode node)
    Adds a synthetic setter for invariant-checked properties when no explicit setter is present.
    Specified by:
      `visitProperty` in interface `GroovyClassVisitor`
    Overrides:
      `visitProperty` in class `ClassCodeVisitorSupport`
    Parameters:
      `node` - the property being visited

  - ### visitClass

    public void visitClass(ClassNode classNode)
    Prepares invariant-check blocks for the class and adds a synthetic default constructor when needed.
    Specified by:
      `visitClass` in interface `GroovyClassVisitor`
    Overrides:
      `visitClass` in class `ClassCodeVisitorSupport`
    Parameters:
      `classNode` - the class being visited